package nl.amis.hrm;

import java.util.ArrayList;
import java.util.List;

import java.sql.Timestamp;

public class EmpManager {
    private List<Emp> emps = new ArrayList();

    private static EmpManager ref;
    
    
    // Private Constructor
    private EmpManager() {
        resetData();
    }

    public static synchronized EmpManager getEmpManager()
     {
       if (ref == null)
           // can call this constructor
           ref = new EmpManager();
       return ref;
     }

    public void resetData() {
        emps = new ArrayList();
        createEmp((long)7369, "SMITH", "CLERK", (long)7902, 
                  new Timestamp(80, 12, 17, 00, 00, 00, 0), (double)800, 
                  null, (long)20);
        createEmp((long)7499, "ALLEN", "SALESMAN", (long)7698, 
                  new Timestamp(81, 2, 20, 00, 00, 00, 0), (double)1600, 
                  (double)300, (long)30);
        createEmp((long)7521, "WARD", "SALESMAN", (long)7698, 
                  new Timestamp(81, 2, 22, 00, 00, 00, 0), (double)1250, 
                  (double)500, (long)30);
        createEmp((long)7566, "JONES", "MANAGER", (long)7839, 
                  new Timestamp(81, 4, 2, 00, 00, 00, 0), (double)2975, null, 
                  (long)20);
        createEmp((long)7654, "MARTIN", "SALESMAN", (long)7698, 
                  new Timestamp(81, 9, 28, 00, 00, 00, 0), (double)1250, 
                  (double)1400, (long)30);
        createEmp((long)7698, "BLAKE", "MANAGER", (long)7839, 
                  new Timestamp(81, 5, 1, 00, 00, 00, 0), (double)2850, null, 
                  (long)30);
        createEmp((long)7782, "CLARK", "MANAGER", (long)7839, 
                  new Timestamp(81, 6, 9, 00, 00, 00, 0), (double)2450, null, 
                  (long)10);
        createEmp((long)7788, "SCOTT", "ANALYST", (long)7566, 
                  new Timestamp(82, 12, 9, 00, 00, 00, 0), (double)3000, 
                  null, (long)20);
        createEmp((long)7839, "KING", "PRESIDENT", null, 
                  new Timestamp(81, 11, 17, 00, 00, 00, 0), (double)5000, 
                  null, (long)10);
        createEmp((long)7844, "TURNER", "SALESMAN", (long)7698, 
                  new Timestamp(81, 9, 8, 00, 00, 00, 0), (double)1500, 
                  (double)0, (long)30);
        createEmp((long)7876, "ADAMS", "CLERK", (long)7788, 
                  new Timestamp(83, 1, 12, 00, 00, 00, 0), (double)1100, 
                  null, (long)20);
        createEmp((long)7900, "JAMES", "CLERK", (long)7698, 
                  new Timestamp(81, 12, 3, 00, 00, 00, 0), (double)950, null, 
                  (long)30);
        createEmp((long)7902, "FORD", "ANALYST", (long)7566, 
                  new Timestamp(81, 12, 3, 00, 00, 00, 0), (double)3000, 
                  null, (long)20);
        createEmp((long)7934, "MILLER", "CLERK", (long)7782, 
                  new Timestamp(82, 1, 23, 00, 00, 00, 0), (double)1300, 
                  null, (long)10);
    }

    public void createEmp(Long empno, String ename, String job, Long mgr, 
                          Timestamp hiredate, Double sal, Double comm, 
                          Long deptno) {
        Emp newEmp = null;
        newEmp = new Emp(empno, ename, job, mgr, hiredate, sal, comm, deptno);
        emps.add(newEmp);
    }

    public Emp findEmp(Long id) {
        // iterate through emps to locate entry where get<PrimaryKeyColumn> equal to id
        // if none are found, return null
        Emp empFound = null;
        for (Emp emp: emps) {
            if (emp.getEmpno().compareTo(id) == 0) {
                empFound = emp;
                break;
            }
        }
        return empFound;
    }

    public void setEmps(List<Emp> emps) {
        this.emps = emps;
    }

    public List<Emp> getEmps() {
        return emps;
    }

    protected Object clone() throws CloneNotSupportedException {
        throw new CloneNotSupportedException("Singleton CLERKttern: sorry no cloning allowed.");
    }
}
